# Text Hover

A plugin for WordPress for adding hover text (aka tooltips) to content in posts. Handy for providing explanations of names, terms, phrases, abbreviations, and acronyms.

This plugin is available in the WordPress Plugin Directory: https://wordpress.org/plugins/text-hover/


## Installation

1. Install via the built-in WordPress plugin installer. Or install the plugin code inside the plugins directory for your site (typically `/wp-content/plugins/`).
2. Activate the plugin through the 'Plugins' admin menu in WordPress.
3. Go to the `Settings` -> `Text Hover` admin settings page and customize the settings (namely to define the terms/abbreviations and their explanations).
4. Optional: Configure other plugin settings as desired.
5. Use the terms/abbreviations in posts/pages. Terms/abbreviations appearing in existing posts will also be affected by this plugin.


## Additional Documentation

* See [readme.txt](https://github.com/coffee2code/text-hover/blob/master/readme.txt) for additional usage information.
* See [DEVELOPER-DOCS.md](DEVELOPER-DOCS.md) for developer-related documentation on hooks.
* See [CHANGELOG.md](CHANGELOG.md) for the list of changes for each release.


## Support

Commercial support and custom development are not presently available. You can raise an [issue](https://github.com/coffee2code/text-hover/issues) on GitHub or post in the [plugin's support forum on WordPress.org](https://wordpress.org/support/plugin/text-hover/).

If the plugin has been of benefit to you, how about [submitting a review](https://wordpress.org/support/plugin/text-hover/reviews/) for it in the WordPress Plugin Directory or considering a [donation](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=6ARCFJ9TX3522)?


## License

This plugin is free software; you can redistribute it and/or modify it under the terms of the [GNU General Public License](https://www.gnu.org/licenses/gpl-2.0.html) as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.